export
class

  AtomList

extends

  {Array}

template

  T

### Type parameters

- #### T

### Hierarchy

- Array<T>
  - AtomList

### Indexable

[n: number]: T

## Index

### Constructors

- constructor

### Properties

- length
- next
- prev
- Array

### Accessors

- size
- start
- total

### Methods

- [Symbol.iterator]
- [Symbol.unscopables]
- add
- addAll
- clear
- concat
- copyWithin
- entries
- every
- fill
- filter
- find
- findIndex
- forEach
- groupBy
- indexOf
- insert
- join
- keys
- lastIndexOf
- map
- pop
- push
- reduce
- reduceRight
- refresh
- remove
- removeAt
- replace
- reverse
- shift
- slice
- some
- sort
- splice
- toLocaleString
- toString
- unshift
- values
- watch

## Constructors

### constructor

- new AtomList(): AtomList

- - Defined in src/core/AtomList.ts:20

  #### Returns AtomList

## Properties

### length

length: number

Inherited from Array.length

- Defined in node_modules/typescript/lib/lib.es5.d.ts:1215

Gets or sets the length of the array. This is a number one higher than the highest element defined in an array.

### next

next: function

- Defined in src/core/AtomList.ts:15

#### Type declaration

- - (): any

  - #### Returns any

### prev

prev: function

- Defined in src/core/AtomList.ts:16

#### Type declaration

- - (): any

  - #### Returns any

### Static Array

Array: ArrayConstructor

- Defined in node_modules/typescript/lib/lib.es5.d.ts:1385

## Accessors

### size

- get size(): number
- set size(v: number): void

- - Defined in src/core/AtomList.ts:60

  #### Returns number

- - Defined in src/core/AtomList.ts:63

  #### Parameters

  - ##### v: number

  #### Returns void

### start

- get start(): number
- set start(v: number): void

- - Defined in src/core/AtomList.ts:38

  #### Returns number

- - Defined in src/core/AtomList.ts:41

  #### Parameters

  - ##### v: number

  #### Returns void

### total

- get total(): number
- set total(v: number): void

- - Defined in src/core/AtomList.ts:49

  #### Returns number

- - Defined in src/core/AtomList.ts:52

  #### Parameters

  - ##### v: number

  #### Returns void

## Methods

### [Symbol.iterator]

- [Symbol.iterator](): IterableIterator<T>

- Inherited from Array.[Symbol.iterator]

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:60

  Iterator

  #### Returns IterableIterator<T>

### [Symbol.unscopables]

- [Symbol.unscopables](): object

- Inherited from Array.[Symbol.unscopables]

  - Defined in node_modules/typescript/lib/lib.es2015.symbol.wellknown.d.ts:94

  Returns an object whose properties have the value 'true' when they will be absent when used in a 'with' statement.

  #### Returns object

### add

- add(item: T): number

- Overrides Array.add

  - Defined in src/core/AtomList.ts:76

  Adds the item in the list and refresh bindings

  memberof

    AtomList

  #### Parameters

  - ##### item: T

  #### Returns number

### addAll

- addAll(items: T[]): void

- Overrides Array.addAll

  - Defined in src/core/AtomList.ts:90

  Add given items in the list and refresh bindings

  memberof

    AtomList

  #### Parameters

  - ##### items: T[]

  #### Returns void

### clear

- clear(): void

- Overrides Array.clear

  - Defined in src/core/AtomList.ts:190

  Removes all items from the list and refreshes the bindings

  memberof

    AtomList

  #### Returns void

### concat

- concat(...items: ConcatArray<T>[]): T[]
- concat(...items: (T | ConcatArray<T>)[]): T[]

- Inherited from Array.concat

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1237

  Combines two or more arrays.

  #### Parameters

  - ##### Rest ...items: ConcatArray<T>[]

    Additional items to add to the end of array1.

  #### Returns T[]

- Inherited from Array.concat

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1242

  Combines two or more arrays.

  #### Parameters

  - ##### Rest ...items: (T | ConcatArray<T>)[]

    Additional items to add to the end of array1.

  #### Returns T[]

### copyWithin

- copyWithin(target: number, start: number, end?: number): this

- Inherited from Array.copyWithin

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:64

  Returns the this object after copying a section of the array identified by start and end to the same array starting at position target

  #### Parameters

  - ##### target: number

    If target is negative, it is treated as length+target where length is the length of the array.

  - ##### start: number

    If start is negative, it is treated as length+start. If end is negative, it is treated as length+end.

  - ##### Optional end: number

    If not specified, length of the this object is used as its default value.

  #### Returns this

### entries

- entries(): IterableIterator<[number, T]>

- Inherited from Array.entries

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:65

  Returns an iterable of key, value pairs for every entry in the array

  #### Returns IterableIterator<[number, T]>

### every

- every(callbackfn: function, thisArg?: any): boolean

- Inherited from Array.every

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1310

  Determines whether all the members of an array satisfy the specified test.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The every method calls the callbackfn function for each element in the array until the callbackfn returns a value which is coercible to the Boolean value false, or until the end of the array.

    - - (value: T, index: number, array: T[]): unknown

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### fill

- fill(value: T, start?: number, end?: number): this

- Inherited from Array.fill

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:53

  Returns the this object after filling the section identified by start and end with value

  #### Parameters

  - ##### value: T

    value to fill array section with

  - ##### Optional start: number

    index to start filling the array at. If start is negative, it is treated as length+start where length is the length of the array.

  - ##### Optional end: number

    index to stop filling the array at. If end is negative, it is treated as length+end.

  #### Returns this

### filter

- filter<S>(callbackfn: function, thisArg?: any): S[]
- filter(callbackfn: function, thisArg?: any): T[]

- Inherited from Array.filter

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1337

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Type parameters

  - #### S: T

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): value is S

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns value is S

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns S[]

- Inherited from Array.filter

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1343

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The filter method calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): unknown

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns T[]

### find

- find<S>(predicate: function, thisArg?: any): S | undefined
- find(predicate: function, thisArg?: any): T | undefined

- Inherited from Array.find

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:31

  Returns the value of the first element in the array where predicate is true, and undefined otherwise.

  #### Type parameters

  - #### S: T

  #### Parameters

  - ##### predicate: function

    find calls predicate once for each element of the array, in ascending order, until it finds one where predicate returns true. If such an element is found, find immediately returns that element value. Otherwise, find returns undefined.

    - - (this: void, value: T, index: number, obj: T[]): value is S

      - #### Parameters

        - ##### this: void

        - ##### value: T

        - ##### index: number

        - ##### obj: T[]

        #### Returns value is S

  - ##### Optional thisArg: any

    If provided, it will be used as the this value for each invocation of predicate. If it is not provided, undefined is used instead.

  #### Returns S | undefined

- Inherited from Array.find

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:32

  #### Parameters

  - ##### predicate: function

    - - (value: T, index: number, obj: T[]): unknown

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### obj: T[]

        #### Returns unknown

  - ##### Optional thisArg: any

  #### Returns T | undefined

### findIndex

- findIndex(predicate: function, thisArg?: any): number

- Inherited from Array.findIndex

  - Defined in node_modules/typescript/lib/lib.es2015.core.d.ts:43

  Returns the index of the first element in the array where predicate is true, and -1 otherwise.

  #### Parameters

  - ##### predicate: function

    find calls predicate once for each element of the array, in ascending order, until it finds one where predicate returns true. If such an element is found, findIndex immediately returns that element index. Otherwise, findIndex returns -1.

    - - (value: T, index: number, obj: T[]): unknown

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### obj: T[]

        #### Returns unknown

  - ##### Optional thisArg: any

    If provided, it will be used as the this value for each invocation of predicate. If it is not provided, undefined is used instead.

  #### Returns number

### forEach

- forEach(callbackfn: function, thisArg?: any): void

- Inherited from Array.forEach

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1325

  Performs the specified action for each element in an array.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): void

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns void

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns void

### groupBy

- groupBy<TKey>(keySelector: function): Array<IKeyedArray<TKey, T>>

- Inherited from Array.groupBy

  - Defined in src/core/types.ts:146

  #### Type parameters

  - #### TKey

  #### Parameters

  - ##### keySelector: function

    - - (item: T): TKey

      - #### Parameters

        - ##### item: T

        #### Returns TKey

  #### Returns Array<IKeyedArray<TKey, T>>

### indexOf

- indexOf(searchElement: T, fromIndex?: number): number

- Inherited from Array.indexOf

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1295

  Returns the index of the first occurrence of a value in an array.

  #### Parameters

  - ##### searchElement: T

    The value to locate in the array.

  - ##### Optional fromIndex: number

    The array index at which to begin the search. If fromIndex is omitted, the search starts at index 0.

  #### Returns number

### insert

- insert(i: number, item: T): void

- Overrides Array.insert

  - Defined in src/core/AtomList.ts:137

  Inserts given number in the list at position `i` and refreshes the bindings.

  memberof

    AtomList

  #### Parameters

  - ##### i: number

  - ##### item: T

  #### Returns void

### join

- join(separator?: string): string

- Inherited from Array.join

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1247

  Adds all the elements of an array separated by the specified separator string.

  #### Parameters

  - ##### Optional separator: string

    A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.

  #### Returns string

### keys

- keys(): IterableIterator<number>

- Inherited from Array.keys

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:70

  Returns an iterable of keys in the array

  #### Returns IterableIterator<number>

### lastIndexOf

- lastIndexOf(searchElement: T, fromIndex?: number): number

- Inherited from Array.lastIndexOf

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1301

  Returns the index of the last occurrence of a specified value in an array.

  #### Parameters

  - ##### searchElement: T

    The value to locate in the array.

  - ##### Optional fromIndex: number

    The array index at which to begin the search. If fromIndex is omitted, the search starts at the last index in the array.

  #### Returns number

### map

- map<U>(callbackfn: function, thisArg?: any): U[]

- Inherited from Array.map

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1331

  Calls a defined callback function on each element of an array, and returns an array that contains the results.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.

    - - (value: T, index: number, array: T[]): U

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns U

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns U[]

### pop

- pop(): T | undefined

- Inherited from Array.pop

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1227

  Removes the last element from an array and returns it.

  #### Returns T | undefined

### push

- push(...items: T[]): number

- Inherited from Array.push

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1232

  Appends new elements to an array, and returns the new length of the array.

  #### Parameters

  - ##### Rest ...items: T[]

    New elements of the Array.

  #### Returns number

### reduce

- reduce(callbackfn: function): T
- reduce(callbackfn: function, initialValue: T): T
- reduce<U>(callbackfn: function, initialValue: U): U

- Inherited from Array.reduce

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1349

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

- Inherited from Array.reduce

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1350

  #### Parameters

  - ##### callbackfn: function

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

  - ##### initialValue: T

  #### Returns T

- Inherited from Array.reduce

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1356

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: T, currentIndex: number, array: T[]): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reduceRight

- reduceRight(callbackfn: function): T
- reduceRight(callbackfn: function, initialValue: T): T
- reduceRight<U>(callbackfn: function, initialValue: U): U

- Inherited from Array.reduceRight

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1362

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

- Inherited from Array.reduceRight

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1363

  #### Parameters

  - ##### callbackfn: function

    - - (previousValue: T, currentValue: T, currentIndex: number, array: T[]): T

      - #### Parameters

        - ##### previousValue: T

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns T

  - ##### initialValue: T

  #### Returns T

- Inherited from Array.reduceRight

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1369

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: T, currentIndex: number, array: T[]): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: T

        - ##### currentIndex: number

        - ##### array: T[]

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### refresh

- refresh(): void

- Overrides Array.refresh

  - Defined in src/core/AtomList.ts:195

  #### Returns void

### remove

- remove(item: T | function): boolean

- Overrides Array.remove

  - Defined in src/core/AtomList.ts:162

  Removes given item or removes all items that match given lambda as true and refresh the bindings

  memberof

    AtomList

  #### Parameters

  - ##### item: T | function

  #### Returns boolean

  `true` if any item was removed

### removeAt

- removeAt(i: number): void

- Overrides Array.removeAt

  - Defined in src/core/AtomList.ts:148

  Removes item at given index i and refresh the bindings

  memberof

    AtomList

  #### Parameters

  - ##### i: number

  #### Returns void

### replace

- replace(items: T[], start?: number, size?: number): void

- Overrides Array.replace

  - Defined in src/core/AtomList.ts:111

  Replaces list with given items, use this to avoid flickering in screen

  memberof

    AtomList

  #### Parameters

  - ##### items: T[]

  - ##### Optional start: number

  - ##### Optional size: number

  #### Returns void

### reverse

- reverse(): T[]

- Inherited from Array.reverse

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1251

  Reverses the elements in an Array.

  #### Returns T[]

### shift

- shift(): T | undefined

- Inherited from Array.shift

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1255

  Removes the first element from an array and returns it.

  #### Returns T | undefined

### slice

- slice(start?: number, end?: number): T[]

- Inherited from Array.slice

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1261

  Returns a section of an array.

  #### Parameters

  - ##### Optional start: number

    The beginning of the specified portion of the array.

  - ##### Optional end: number

    The end of the specified portion of the array. This is exclusive of the element at the index 'end'.

  #### Returns T[]

### some

- some(callbackfn: function, thisArg?: any): boolean

- Inherited from Array.some

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1319

  Determines whether the specified callback function returns true for any element of an array.

  #### Parameters

  - ##### callbackfn: function

    A function that accepts up to three arguments. The some method calls the callbackfn function for each element in the array until the callbackfn returns a value which is coercible to the Boolean value true, or until the end of the array.

    - - (value: T, index: number, array: T[]): unknown

      - #### Parameters

        - ##### value: T

        - ##### index: number

        - ##### array: T[]

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### sort

- sort(compareFn?: function): this

- Inherited from Array.sort

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1271

  Sorts an array.

  #### Parameters

  - ##### Optional compareFn: function

    Function used to determine the order of the elements. It is expected to return a negative value if first argument is less than second argument, zero if they're equal and a positive value otherwise. If omitted, the elements are sorted in ascending, ASCII character order.

        [11,2,22,1].sort((a, b) => a - b)

    - - (a: T, b: T): number

      - #### Parameters

        - ##### a: T

        - ##### b: T

        #### Returns number

  #### Returns this

### splice

- splice(start: number, deleteCount?: number): T[]
- splice(start: number, deleteCount: number, ...items: T[]): T[]

- Inherited from Array.splice

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1277

  Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.

  #### Parameters

  - ##### start: number

    The zero-based location in the array from which to start removing elements.

  - ##### Optional deleteCount: number

    The number of elements to remove.

  #### Returns T[]

- Inherited from Array.splice

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1284

  Removes elements from an array and, if necessary, inserts new elements in their place, returning the deleted elements.

  #### Parameters

  - ##### start: number

    The zero-based location in the array from which to start removing elements.

  - ##### deleteCount: number

    The number of elements to remove.

  - ##### Rest ...items: T[]

    Elements to insert into the array in place of the deleted elements.

  #### Returns T[]

### toLocaleString

- toLocaleString(): string

- Inherited from Array.toLocaleString

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1223

  Returns a string representation of an array. The elements are converted to string using their toLocalString methods.

  #### Returns string

### toString

- toString(): string

- Inherited from Array.toString

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1219

  Returns a string representation of an array.

  #### Returns string

### unshift

- unshift(...items: T[]): number

- Inherited from Array.unshift

  - Defined in node_modules/typescript/lib/lib.es5.d.ts:1289

  Inserts new elements at the start of an array.

  #### Parameters

  - ##### Rest ...items: T[]

    Elements to insert at the start of the Array.

  #### Returns number

### values

- values(): IterableIterator<T>

- Inherited from Array.values

  - Defined in node_modules/typescript/lib/lib.es2015.iterable.d.ts:75

  Returns an iterable of values in the array

  #### Returns IterableIterator<T>

### watch

- watch(f: function, wrap?: boolean): IDisposable

- Overrides Array.watch

  - Defined in src/core/AtomList.ts:201

  #### Parameters

  - ##### f: function

    - - (target: any, key: string, index?: number, item?: any): void

      - #### Parameters

        - ##### target: any

        - ##### key: string

        - ##### Optional index: number

        - ##### Optional item: any

        #### Returns void

  - ##### Optional wrap: boolean

  #### Returns IDisposable

Generated using TypeDoc